QGIS Application - Bug report #10560
Wrong feature count after edit
2014-06-12 01:37 AM - Saber Razmjooei

Status: Closed

Priority: Severe/Regression
Assignee:

Category: Data Provider/OGR

Affected QGIS version:master
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: fixed/implemented

Copied to github as #: 18967

Description

Feature count in QGIS master (commit:21f0b4f) reports wrong number of features after edit.

To reproduce:
- Open a vector layer

- Toggle editing
- Add or delete features (number of features is still correct)
- Save edits

Feature count resets to the original number

The bug is notin 2.2

Right-click on the layer from layer tree and enable Feature count (the number of features is correct at this stage)

Related issues:

Related to QGIS Application - Bug report # 12660: Feature count on SHP file I...
Related to QGIS Application - Bug report # 11007: Deleted/edited features wit...

Closed
Closed

2015-04-27
2014-08-05

Associated revisions

Revision f581e20c - 2014-06-13 11:41 AM - Martin Dobias

Fix #10560 (wrong feature count)

Revision 7d7cdcd3 - 2015-05-28 12:34 PM - Matthias Kuhn

Repack shapefiles when saving after deleting features

- QgsVectorDataProvider::dataChanged() will be emitted
- QgsVectorLayer::dataChanged() will be emitted

- Clears QgsVectorLayerCache

- Reloads the attribute table

- Clears the selection

Looking forward to people complaining about their lost selection...

Fix #10560
Fix #11989
Refs #8317
Refs #8822
Refs #10483
Refs #11007
Refs #7540
Refs #11398
Refs #11296

History

#1 - 2014-06-12 02:29 AM - Martin Dobias
- Assignee set to Martin Dobias

#2 - 2014-06-13 02:41 AM - Martin Dobias
- Status changed from Open to Closed

Fixed in changeset commit:"f581e20c44d746590a9454{397218ebe501e6a9c".

#3 - 2014-11-26 01:41 AM - Steve Lowman
- Target version set to Version 2.6

- Status changed from Closed to Reopened

This bug is occurring in 2.6.

#4 - 2014-11-26 01:18 PM - Giovanni Manghi

- Affected QGIS version changed from 2.2.0 to 2.6.0
- Status changed from Reopened to Feedback

- Target version deleted (Version 2.6)

Steve Lowman wrote:

This bug is occurring in 2.6.

cannot confirm on gqgis master, please give it a try and report back.

#5 - 2014-11-27 01:35 PM - Nyall Dawson

| can confirm this on master, when editing a shapefile.

#6 - 2015-02-10 01:35 AM - Martin Dobias
- Assignee deleted (Martin Dobias)
- Status changed from Feedback to Open

| confirm it too - it's the same problem like in #11007 and #11989 with shapefiles that have not been repacked

#7 - 2015-02-13 08:45 AM - Jiirgen Fischer
- Category set to Data Provider/OGR
#8 - 2015-05-21 07:10 AM - Saber Razmjooei
- Status changed from Open to Closed

Works fine in 2.8.2.

#9 - 2015-05-21 12:01 PM - Steve Lowman
- Status changed from Closed to Reopened

| tested it in 2.8.2. The bug still exists.

| paste a couple of copied features into the layer. The count changes from 0 to 2. All good so far.
| save the change. The count stays at 2. All correct still.

| delete one of the features. The count reduces to 1. Still good.

| save the change. The count changes back to 2. Oh dear, not so good.

#10 - 2015-05-21 11:18 PM - Giovanni Manghi

- Affected QGIS version changed from 2.6.0 to master
- OS version deleted (7)

- Operating System deleted (Windows)

#11 - 2015-05-28 03:03 AM - Matthias Kuhn

Pull request ready.

https://github.com/qgis/QGIS/pull/2086

Most relevant discussion can be found in:
#11007

#12 - 2015-05-28 03:35 AM - Matthias Kuhn

- Status changed from Reopened to Closed

Fixed in changeset commit:"7d7cdcd376c0d3fa60af1403a91e1e611b210174".

#13 - 2016-05-31 04:45 AM - Steve Lowman
- Status changed from Closed to Reopened

This bug is occurring again in 2.14.3. Feature count has been working fine for a while, but whatever the change that fixed i, it seems to have been

reversed.

#14 - 2016-05-31 12:17 PM - R. R.

Feature count for shape files seems to work properly here on Ubuntu 16.04 LTS (1:2.14.3+git20160529+7d7467f+24xenial). Can you provide a list of

steps to reproduce the issue?
https://github.com/qgis/QGIS/pull/2086

#15 - 2016-06-01 03:31 AM - Steve Lowman
Yep, I'min W10. How to reproduce this...

. New project file.

. New shapefile layer.

. Check 'Show Feature Count' for new layer.

.'Add Features' tool, digitise some features, e.g. 2 features. (Feature Count updates correctly - reads '2').

. Digitise one more feature, and save layer edits. (Feature Count still correct - reads '3').

1
2

3

4

5. Save Layer Edits. (Feature Count stays correct - reads '2').

6

7. Select and delete one of your features. (Feature Count reduces correctly - reads '2').
8

. Save Layer Edits. (Feature Count incorrectly reverts to previous value - reads '3').

#16 - 2016-06-02 12:34 PM - R. R.
- File 10560_qgis-2-14-3.mp4 added

Hi Steve, thanks for your reply. | can't confirm this issue on Ubuntu 16.04 LTS (see screencast).

#17 - 2016-06-02 11:45 PM - R. R.
Steve Lowman wrote:

8. Save Layer Edits. (Feature Count incorrectly reverts to previous value - reads '3').

| can confirm this on Win7 (QGIS 2.14.3)!

Related: #14859 - Feature count issue (PostGIS view)

#18 - 2016-06-30 04:27 AM - Andreas Neumann
- File qgis-rel-dev.png added

I just tested this with a shapefile on Windows 7 with QGIS 2.15 (master) and QGIS 2.14 (#843d17e ) and aren't able to reproduce this issue.

@Reinhard and/or Steve: can you please test with #843d17e - you can install it using the OSGeo4W installer (
http://download.osgeo.org/osgeo4w/osgeodw-setup-x86_64.exe) by chosing "QGIS Rel Dev" in the "Desktop” section.

#19 - 2016-06-30 10:53 AM - Giovanni Manghi

- Status changed from Reopened to Feedback

#20 - 2016-06-30 11:01 AM - Giovanni Manghi

- Status changed from Feedback to Closed

- Resolution set to fixed/implemented

this is very likely related to #11007

the issue has been solved in master and backported to the development branch of 2.14
http://download.osgeo.org/osgeo4w/osgeo4w-setup-x86_64.exe

#21 - 2016-07-01 01:05 AM - R. R.

I've done the steps above in QGIS 2.15 master 600ff4f and 'Show Feature Count' works as expected.

(Win7)

#22 - 2016-10-04 07:11 AM - Ervin Wirth

- Status changed from Closed to Reopened

- File qgisissue.png added

The problem still exist with 2.16.2 after removing some features with PyQGIS codelines and commit changes.
Windows 7 x64.

#23 - 2016-10-07 03:29 AM - Even Rouault
- Status changed from Reopened to Feedback

@Ervin, could you provide a self contained script + dataset that reproduces the issue ?

#24 - 2016-10-19 05:18 AM - Matthias Kuhn
- Status changed from Feedback to Closed

@Ervin, make sure you use the layer.add/remove/etcFeature() methods and not layer.dataProvider().add/remove/etcFeature() methods.

Will close this until someone can provide a script/data to reproduce.

Files

10560_qgis-2-14-3.mp4 876 KB 2016-06-02 R.R.

qgis-rel-dev.png 277 KB 2016-06-30 Andreas Neumann

qgisissue.png 169 KB 2016-10-04 Ervin Wirth
